package package1;

import java.sql.*;
import java.util.*;
import java.io.*;

public class ColaboraBean {

private Connection conn;

  public ColaboraBean() {
  }

  public void setConnection( Connection c) {
    conn = c;
  }

  public String novoColaborador(String nome, String foto, String funcao, String local, String ano) {
    int codigo=-1;
    int educador;
    try {
      Statement stmt = conn.createStatement();
      ResultSet rs =  stmt.executeQuery("select max(codigo) from colaboradores");
      if (rs.next()) codigo = rs.getInt("max(codigo)") + 1;
      else codigo = 1;

      educador = funcao.compareTo("Educadora");
      
      String sql;
      if(educador == 0) {
          sql = "INSERT INTO colaboradores (local, ano, codigo, fun__o, fotografia, nome) VALUES ( ?, ?, ?, ?, ?, ?)";
      }
      else {
          sql = "INSERT INTO colaboradores (codigo, fun__o, fotografia, nome) VALUES ( ?, ?, ?, ?)";
      }
          
      PreparedStatement ps = conn.prepareStatement(sql);

      int paramindex = 1;

      byte[] fotoBuf = ByteFileStream.read(foto);
      ByteArrayInputStream bais = new ByteArrayInputStream(fotoBuf);

      if(educador == 0) {
        ps.setString(paramindex++, local);
        ps.setInt(paramindex++, Integer.valueOf(ano).intValue());
      }
      ps.setInt(paramindex++, codigo);
      ps.setString(paramindex++, funcao);
      ps.setBinaryStream(paramindex++, bais, fotoBuf.length);
      ps.setString(paramindex++, nome);

      ps.executeUpdate();
      ps.close();
    }
    catch ( SQLException se ) {
      return "Couldn't insert data: "+se;
    }
        
    return String.valueOf("Insert success: Codigo="+ codigo);
  }

  public Vector listaColaboradores() {
    Vector lista = new Vector();

    try {
      Statement smt = conn.createStatement();
      String sql = "select codigo, nome " +
                   "from colaboradores";

      ResultSet rs = smt.executeQuery(sql);

      while(rs.next()) {
        lista.addElement(new Integer(rs.getInt("codigo")));
        lista.addElement(rs.getString("nome"));
      }
    }
    catch ( SQLException se ) {
      System.err.println(se);
      return null;
    }

    return lista;
  }


  public Vector getColaborador(String nome) {
    byte[] returndata = null;
    Vector byteVector = new Vector(); //para a fotografia
    Vector colaboradorDados = new Vector();
    int codigo = -1;

    try {
      Statement sment = conn.createStatement();
      String sql = "select codigo, nome, fotografia, fun__o, local, ano " +
                   "from colaboradores where nome = '" + nome + "'";

      ResultSet rs = sment.executeQuery(sql);
      System.out.println("Nome: " + nome);

      if(rs.next()) {

        int photoID = rs.getInt("codigo");
        colaboradorDados.addElement(rs.getString("nome"));

        BufferedInputStream bis = new BufferedInputStream( rs.getBinaryStream("fotografia") );
        ByteFileStream.CreateFile(bis, new String("colabor" + photoID + ".jpg"));
        colaboradorDados.addElement(new String("colabor" + photoID + ".jpg"));

        String funcao = null;
        funcao = rs.getString("fun__o");
        colaboradorDados.addElement(funcao);

        if(funcao.compareTo("Educadora") == 0) {
           colaboradorDados.addElement(rs.getString("local"));
           colaboradorDados.addElement(new Integer(rs.getInt("ano")));
        }
        rs.close();
        sment.close();
      }
   }
   catch ( SQLException se ) {
      System.err.println("===>Couldn't retrieve binary data: " + se);
      return null;
   }

   return colaboradorDados;

  }

  public Vector dadosColaborador(String codigo) {
    byte[] returndata = null;
    Vector byteVector = new Vector(); //para a fotografia
    Vector colaboradorDados = new Vector();
    int cod = Integer.valueOf(codigo).intValue();

    System.out.println("Codigo= " + cod);

    try {
      Statement stmt = conn.createStatement();
      String sql = "select nome, fotografia, fun__o, local, ano " +
                   "from colaboradores where codigo = " + cod;

      ResultSet rs = stmt.executeQuery(sql);

      if(rs.next()) {
        int photoID = cod;
        colaboradorDados.addElement(rs.getString("nome"));
        BufferedInputStream bis = new BufferedInputStream( rs.getBinaryStream("fotografia") );
        ByteFileStream.CreateFile(bis, new String("colabor" + photoID + ".jpg"));
        colaboradorDados.addElement(new String("colabor" + photoID + ".jpg"));

        String funcao = null;
        funcao = rs.getString("fun__o");
        colaboradorDados.addElement(funcao);

        if(funcao.compareTo("Educadora") == 0) {
          colaboradorDados.addElement(rs.getString("local"));
          colaboradorDados.addElement(String.valueOf(rs.getInt("ano")));
        }
        rs.close();
        stmt.close();
      }
    }
    catch ( SQLException se ) {
      System.err.println("===>Couldn't retrieve binary data: " + se);
      return null;
    }

   return colaboradorDados;
  }
}