package package1;

import java.sql.*;
import java.util.*;
import java.io.*;
import java.text.*;

public class InscInfBean {

private Connection conn;
private int codigoEnc = -1;
private int codigoCrianca = -1;
private int idade = -1;
private int ano = -1;
private int codigoTurma = -1;
private Vector dadosCrianca;
private Vector listaActividades;
private Vector listaActividadesInscritas;

  public InscInfBean() {
  }

  public void setConnection( Connection c) {
    conn = c;
  }

  public int numeroVagas(String idadeCrianca) {

     idade = Integer.valueOf(idadeCrianca).intValue();
     ano = getCurrentYear();
     System.out.println("Idade: "+ idade);
     Statement stmt;
     ResultSet rs;

     int capacidade, nInscritos;

     if(getCurrentMonth() < 9) ano--; /*ano lectivo anterior*/
     System.out.println("Ano: "+ ano);

     try {
      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select count(c.codigo) "+
                              "from turmas t, criancas c "+
                              "where t.ano = " + ano + "and t.idade_max = " + idade + "and c.tur_codigo=t.codigo");
      rs.next();
      nInscritos = rs.getInt("count(c.codigo)");
      stmt.close();
      System.out.println("Numero de inscritos: " + nInscritos);

      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select capacidade, codigo "+
                              "from turmas "+
                              "where ano = " + ano + " and idade_max = " + idade);

      rs.next();
      capacidade = rs.getInt("capacidade");
      codigoTurma = rs.getInt("codigo");
      stmt.close();
     }
     catch ( SQLException se ) {
      System.out.println("Couldn't execute query: "+se);
       return -1;
    }
    System.out.println("Vagas= " + (capacidade - nInscritos));
    return capacidade - nInscritos;
  }

  public String novoEncarregado(String nome, String parentesco, String localTrab,
        String morada, String numCont, String telCasa, String telTrab) {

    int codigo=-1;
    try {
      Statement stmt = conn.createStatement();
      ResultSet rs =  stmt.executeQuery("select max(codigo) from encarregados");
      if (rs.next()) codigo = rs.getInt("max(codigo)") + 1;
      else codigo = 1;
      stmt.close();

      String sql = "INSERT INTO encarregados (morada, parentesco, local_de_trabalho, no__contribuinte, codigo, nome, telefone_casa, telefone_trabalho) VALUES ( ?, ?, ?, ?, ?, ?, ?, ? )";

      PreparedStatement ps = conn.prepareStatement(sql);

      int paramindex = 1;

      ps.setString(paramindex++, morada);
      ps.setString(paramindex++, parentesco);
      ps.setString(paramindex++, localTrab);
      ps.setInt(paramindex++, Integer.valueOf(numCont).intValue());
      ps.setInt(paramindex++, codigo);
      ps.setString(paramindex++, nome);
      ps.setInt(paramindex++, Integer.valueOf(telCasa).intValue());
      ps.setInt(paramindex++, Integer.valueOf(telTrab).intValue());

      ps.executeUpdate();
      ps.close();
      codigoEnc = codigo;
    }
    catch ( SQLException se ) {
      return "Couldn't insert data: "+se;
    }

    System.out.println("Inserted NEW encarregado");
    return "Inserted NEW encarregado";
  }

  public String novaCrianca(String nome, String cedula, String foto, String sexo, String dia_nasc, String mes_nasc, String ano_nasc, String morada, String necess) {
    int codigo=-1;
    Statement stmt;
    ResultSet rs;
    String datanasc;
    listaActividadesInscritas = new Vector();

    System.out.println("NOVA CRIANCA");
    System.out.println("=input= Data Nascimento: " + dia_nasc + "-" + mes_nasc + "-" + ano_nasc);


    if(Integer.valueOf(dia_nasc).intValue() < 10)
      datanasc = new String(ano_nasc + "-" + mes_nasc + "-0" + dia_nasc);
    else
      datanasc = new String(ano_nasc + "-" + mes_nasc + "-" + dia_nasc);

    System.out.println("Data Nascimento: " + datanasc);
    
    try {
      
      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select max(codigo) from criancas");
      if (rs.next()) codigo = rs.getInt("max(codigo)") + 1;
      else codigo = 1;
      stmt.close();

      String sql = "INSERT INTO criancas (data_entrada, codigo, nome, data_nascimento, necessidade, sexo, fotografia, morada, num_cedula, tur_codigo, enc_codigo) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )";
      PreparedStatement ps = conn.prepareStatement(sql);

      System.out.println("Before reading file... File name = " + foto);
      byte[] fotoBuf = ByteFileStream.read(foto);
      ByteArrayInputStream bais = new ByteArrayInputStream(fotoBuf);

      System.out.println("Read PHOTO");

      int paramindex = 1;
      ps.setDate(paramindex++, java.sql.Date.valueOf(datanasc));
      ps.setInt(paramindex++, codigo);
      ps.setString(paramindex++, nome);
      ps.setDate(paramindex++, new java.sql.Date(new java.util.Date().getTime()));
      ps.setString(paramindex++, necess);
      ps.setString(paramindex++, sexo);
      ps.setBinaryStream(paramindex++, bais, fotoBuf.length);
      ps.setString(paramindex++, morada);
      ps.setInt(paramindex++, Integer.valueOf(cedula).intValue());
      ps.setInt(paramindex++, codigoTurma);
      ps.setInt(paramindex++, codigoEnc);

      ps.executeUpdate();
      ps.close();
    }
    catch ( SQLException se ) {
      System.out.println("Couldn't insert data: "+se);
      return "Couldn't insert data: "+se;
    }
    codigoCrianca = codigo;
    System.out.println("Inserted NEW crianca");
    criancaDados(nome);
    return "Inserted NEW crianca";
  }

   public String registarInscricao(String mensalidade, String activ) {
    int codigo=-1;
    int actividade=Integer.valueOf(activ).intValue();
    try {
      Statement stmt = conn.createStatement();
      ResultSet rs =  stmt.executeQuery("select max(codigo) from inscricoes");
      if (rs.next()) codigo = rs.getInt("max(codigo)") + 1;
      else codigo = 1;
      stmt.close();

      String sql = "INSERT INTO inscricoes (preco, codigo, data, act_codigo, cri_codigo) VALUES ( ?, ?, ?, ?, ?)";
      PreparedStatement ps = conn.prepareStatement(sql);

      int paramindex = 1;
      ps.setInt(paramindex++, Integer.valueOf(mensalidade).intValue());
      ps.setInt(paramindex++, codigo);
      ps.setDate(paramindex++, new java.sql.Date(new java.util.Date().getTime()));
      ps.setInt(paramindex++, actividade);
      ps.setInt(paramindex++, codigoCrianca);

      ps.executeUpdate();
      ps.close();
    }
    catch ( SQLException se ) {
      return "Couldn't insert data: "+se;
    }
    System.out.println("Inserted NEW inscricao");
    if(actividade != 0) //0 -> codigo de inscricao no infantario
      listaActividadesInscritas.addElement(String.valueOf(actividade));
    return "Inserted NEW inscricao (Actividade= " + actividade + ")";
  }


  public int getCurrentYear() {
    java.util.Date date = new java.util.Date();

    String dateTempString=new String();
    try{
      SimpleDateFormat formatter = new SimpleDateFormat ("yyyy");
      dateTempString = formatter.format(date);
    } catch(Exception e) { e.printStackTrace();}

    return new Integer(dateTempString).intValue();
  }

  public int getCurrentMonth() {
    java.util.Date date = new java.util.Date();

    String dateTempString=new String();
    try{
      SimpleDateFormat formatter = new SimpleDateFormat ("MM");
      dateTempString = formatter.format(date);
    } catch(Exception e) { e.printStackTrace();}

    return new Integer(dateTempString).intValue();
  }

  public String criancaDados(String nome) {
    ResultSet rs;
    Statement stmt;
    dadosCrianca = new Vector();

    try   {
		  stmt = conn.createStatement ();
		  rs =  stmt.executeQuery("select codigo, fotografia " +
                              "from criancas " +
                              "where nome= '" + nome + "'");

      int photoID = 0;
      if(rs.next()) {
        photoID = rs.getInt("codigo");
        BufferedInputStream bis = new BufferedInputStream( rs.getBinaryStream("fotografia") );
        ByteFileStream.CreateFile(bis, new String("crianca" + photoID+ ".jpg"));
        dadosCrianca.addElement(new Integer(rs.getInt("codigo")));
        dadosCrianca.addElement(nome);
        dadosCrianca.addElement(new String("crianca" + photoID+ ".jpg"));
        stmt.close();
        return new String("crianca" + photoID+ ".jpg");
      }
      else {
        stmt.close();
        return null;
      }
    }
    catch (SQLException e){
      System.out.println("Error in getting criancas from db");
		  return null;
    }
  }

  public Vector actividadesDados() {
    ResultSet rs;
    Statement stmt;
    listaActividades = new Vector();

    try   {
		  stmt = conn.createStatement ();
		  rs =  stmt.executeQuery("select codigo, descricao " +
                              "from actividades");

      while(rs.next()) {
        if(rs.getInt("codigo") != 0) { //0 -> codigo de inscricao infantario
          listaActividades.addElement(String.valueOf(rs.getInt("codigo")));
          listaActividades.addElement(rs.getString("descricao"));
        }
      }
      stmt.close();
    }
    catch (SQLException e){
      System.out.println("Error: " + e);
		  return null;
    }

    return listaActividades;
  }

  public Vector getListaActividades() {
    return listaActividades;
  }

  public Vector getConfirmacaoInscricao() {
    Vector dados = new Vector();
    ResultSet rs;
    Statement stmt;
    String nomeTurma;
    String nomeColaborador;

    System.out.println("Called getConfirmacao");
    try   {
		  stmt = conn.createStatement ();
		  rs =  stmt.executeQuery("select t.nome TURMA, c.nome COLABORADOR " +
                              "from turmas t, colaboradores c " +
                              "where t.col_codigo = c.codigo and t.codigo = " + codigoTurma);
      rs.next();
      nomeTurma = rs.getString("TURMA");
      nomeColaborador = rs.getString("COLABORADOR");
      stmt.close();


    }
    catch (SQLException e){
      System.out.println("Error: " + e);
		  return null;
    }

    dados.addElement(dadosCrianca.elementAt(1)); //nome da crianca
    dados.addElement(dadosCrianca.elementAt(2)); //foto da crianca
    dados.addElement(nomeTurma);
    dados.addElement(nomeColaborador);

    System.out.println("Saved child name, foto, turma, colaborador");

    String codActividadeInscrita;
    String codActividade;
    String actividade;

    System.out.println("listaActividadesInscritas= " + listaActividadesInscritas.size());
    System.out.println("listaActividades= " + listaActividades.size());

    for(int i=0; i < listaActividadesInscritas.size(); i++) {
      codActividadeInscrita = (String)listaActividadesInscritas.elementAt(i);
      for(int j=0; j < listaActividades.size(); j+=2) {
        codActividade = (String)listaActividades.elementAt(j);
        actividade = (String)listaActividades.elementAt(j+1);

        if(codActividadeInscrita.compareTo(codActividade) == 0) {
          dados.addElement(actividade);
        }
      }
    }
    System.out.println("Got Data...");
    return dados;
  }
}
