package package1;

import java.sql.*;
import java.util.*;
import java.io.*;

public class OcorreBean {

private Connection conn;
private Vector dadosCrianca;

  public OcorreBean() {
  }

  public void setConnection( Connection c) {
    conn = c;
  }

  public String criancaDados(String nome) {
    ResultSet rs;
    Statement stmt;
    dadosCrianca = new Vector();

    try   {
		  stmt = conn.createStatement ();
		  rs =  stmt.executeQuery("select codigo, fotografia " +
                              "from criancas " +
                              "where nome= '" + nome + "'");

      int photoID = 0;
      if(rs.next()) {
        photoID = rs.getInt("codigo");
        BufferedInputStream bis = new BufferedInputStream( rs.getBinaryStream("fotografia") );
        ByteFileStream.CreateFile(bis, new String("crianca" + photoID + ".jpg"));
        dadosCrianca.addElement(new Integer(rs.getInt("codigo")));
        dadosCrianca.addElement(nome);
        dadosCrianca.addElement(new String("crianca" + photoID + ".jpg"));
        stmt.close();
        return new String("crianca" + photoID + ".jpg");
      }
      else {
        stmt.close();
        return null;
      }
    }
    catch (SQLException e){
      System.out.println("Error in getting criancas from db");
		  return null;
    }
  }

  public Vector listaColaboradores() {
    ResultSet rs;
    Statement stmt;
    Vector lista = new Vector();

    try   {
		  stmt = conn.createStatement ();
		  rs =  stmt.executeQuery("select codigo, nome from colaboradores");

      while(rs.next()) {
        lista.addElement(String.valueOf(rs.getInt("codigo")));
        lista.addElement(rs.getString("nome"));
      }

      stmt.close();
    }
    catch (SQLException e){
      System.out.println("Error in getting criancas from db");
		  return null;
    }

    return lista;
  }

  public Vector registarOcorrencia(String codColaborador, String dia, String mes, String ano, String hora, String minutos, String descricao) {
    int codigo=-1;
    Vector confirmacao = new Vector();
    String colaborador;
    Statement stmt;
    ResultSet rs;

    try {
      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select max(codigo) from ocorrencias");
      if (rs.next()) codigo = rs.getInt("max(codigo)") + 1;
      else codigo = 1;
      stmt.close();

      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select nome from colaboradores where codigo = " + Integer.valueOf(codColaborador).intValue());
      rs.next();
      colaborador = rs.getString("nome");
      stmt.close();

      String sql = "INSERT INTO ocorrencias (data, descricao, hora, codigo, cri_codigo, col_codigo) VALUES ( ?, ?, ?, ?, ?, ?)";

      PreparedStatement ps = conn.prepareStatement(sql);

      String date;
      if(Integer.valueOf("dia").intValue() < 10)
        date = new String(ano + "-" + mes + "-0" + dia);
      else
        date = new String(ano + "-" + mes + "-" + dia);

      System.out.println("Date: " + date);
      String time = new String(hora + ":" + minutos + ":00");
      System.out.println("Time: " + time);

      int codCrianca = ((Integer)dadosCrianca.elementAt(0)).intValue();

      int paramindex = 1;
      ps.setDate(paramindex++, java.sql.Date.valueOf(date));
      ps.setString(paramindex++, descricao);
      ps.setTime(paramindex++, java.sql.Time.valueOf(time));
      ps.setInt(paramindex++, codigo);
      ps.setInt(paramindex++, codCrianca);
      ps.setInt(paramindex++, Integer.valueOf(codColaborador).intValue());

      // Finally, execute the command and close the statement:
      ps.executeUpdate();
      ps.close();

      confirmacao.addElement((String)dadosCrianca.elementAt(1)); //nome da crianca
      confirmacao.addElement((String)dadosCrianca.elementAt(2)); //nome do ficheiro da foto
      confirmacao.addElement(colaborador);

      switch(Integer.valueOf(mes).intValue()) {
        case 1: confirmacao.addElement(new String(dia + " Janeiro " + ano)); break;
        case 2: confirmacao.addElement(new String(dia + " Fevereiro " + ano)); break;
        case 3: confirmacao.addElement(new String(dia + " Maro " + ano)); break;
        case 4: confirmacao.addElement(new String(dia + " Abril " + ano)); break;
        case 5: confirmacao.addElement(new String(dia + " Maio " + ano)); break;
        case 6: confirmacao.addElement(new String(dia + " Junho " + ano)); break;
        case 7: confirmacao.addElement(new String(dia + " Julho " + ano)); break;
        case 8: confirmacao.addElement(new String(dia + " Agosto " + ano)); break;
        case 9: confirmacao.addElement(new String(dia + " Setembro " + ano)); break;
        case 10: confirmacao.addElement(new String(dia + " Outubro " + ano)); break;
        case 11: confirmacao.addElement(new String(dia + " Novembro " + ano)); break;
        case 12: confirmacao.addElement(new String(dia + " Dezembro " + ano)); break;
        default: break;
      }
    }
    catch ( SQLException se ) {
      System.out.println(se);
      return null;
    }

    return confirmacao;
  }

  public Vector dadosOcorrencias() {
    Vector dados = new Vector();
    int codCrianca = ((Integer)dadosCrianca.elementAt(0)).intValue();
    String nomeCrianca = (String)dadosCrianca.elementAt(1);
    String fotoCrianca = (String)dadosCrianca.elementAt(2);

    dados.addElement(nomeCrianca);
    dados.addElement(fotoCrianca);

    Statement stmt;
    ResultSet rs;

    try {
      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select o.data Data, o.hora Hora, c.nome Colaborador, o.descricao Descricao " +
                              "from ocorrencias o, colaboradores c " +
                              "where o.cri_codigo = " + codCrianca +
                              " and o.col_codigo = c.codigo");
      while(rs.next()) {
        String date = rs.getDate("Data").toString(); //return yyyy-mm-dd
        System.out.println("=> Date: " + date);
        String ano = date.substring(0, 4);
        System.out.println("=> Mes: " + date.substring(5, 7));
        int mes = Integer.valueOf(date.substring(5, 7)).intValue();
        String dia = date.substring(8, 10);
        String data = null;

        switch(mes) {
          case 1: data = new String(dia + " Janeiro " + ano); break;
          case 2: data = new String(dia + " Fevereiro " + ano); break;
          case 3: data = new String(dia + " Maro " + ano); break;
          case 4: data = new String(dia + " Abril " + ano); break;
          case 5: data = new String(dia + " Maio " + ano); break;
          case 6: data = new String(dia + " Junho " + ano); break;
          case 7: data = new String(dia + " Julho " + ano); break;
          case 8: data = new String(dia + " Agosto " + ano); break;
          case 9: data = new String(dia + " Setembro " + ano); break;
          case 10: data = new String(dia + " Outubro " + ano); break;
          case 11: data = new String(dia + " Novembro " + ano); break;
          case 12: data = new String(dia + " Dezembro " + ano); break;
          default: break;
        }

        String time = rs.getTime("Hora").toString(); //returns hh:mm:ss
        System.out.println("=> Time: " + time);
        String hour = time.substring(0, 2);
        String minutes = time.substring(3, 5);
        String hora = new String(hour + "h" + minutes);

        dados.addElement(data);
        dados.addElement(hora);
        dados.addElement(rs.getString("Colaborador"));
        dados.addElement(rs.getString("Descricao"));
      }
      stmt.close();
    }
    catch ( SQLException se ) {
      System.out.println(se);
      return null;
    }

    return dados;
  }
}
