package package1;

import java.sql.*;
import java.util.*;
import java.io.*;
import java.text.*;

public class PagamentosBean {

private Connection conn;
private Vector dadosCrianca;
private int pagamentosEmFalta;
private Vector listaActividades;
private Vector dados;

  public PagamentosBean() {
  }

  public void setConnection( Connection c) {
    conn = c;
  }

  public Vector listaPagamentos() {
    dados = new Vector();
    int codCrianca = ((Integer)dadosCrianca.elementAt(0)).intValue();
    String nomeCrianca = (String)dadosCrianca.elementAt(1);
    String fotoCrianca = (String)dadosCrianca.elementAt(2);

    dados.addElement(nomeCrianca);
    dados.addElement(fotoCrianca);

    System.out.println("Saved in vector child data");

    Statement stmt;
    ResultSet rs;


    int month = getCurrentMonth() - 8; /*number months 1(sep) to 10(june)*/
    int numPagamentos = -1;
    int numActividades = -1;

    try {
      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select count(r.ins_codigo) N_Pagamentos " +
                              "from recibos r, inscricoes i, criancas c " +
                              "where i.cri_codigo = c.codigo and r.ins_codigo = i.codigo and c.codigo = " + codCrianca);
      System.out.println("It did the select1");
      rs.next();
      numPagamentos = rs.getInt("N_Pagamentos");
      stmt.close();
      System.out.println("Numero de Pagamentos Feitos:" + numPagamentos);

      /*get actividades inscritas*/
      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select a.codigo CODIGO, a.descricao Actividade, i.preco Preco " +
                              "from inscricoes i, criancas c, actividades a " +
                              "where i.cri_codigo = c.codigo and i.act_codigo = a.codigo and i.cri_codigo = " + codCrianca);
      System.out.println("It did the select2");

      listaActividades = new Vector();
      while(rs.next()) {
        //listaActividades.addElement(new Integer(rs.getInt("CODIGO")));
        listaActividades.addElement(rs.getString("Actividade"));
        listaActividades.addElement(new Integer(rs.getInt("Preco")));
      }
      numActividades = listaActividades.size()/2;
      System.out.println("Numero de actividades: " + numActividades);
      stmt.close();
    }
    catch ( SQLException se ) {
      System.out.println(se);
      return null;
    }
    /*PRINT LISTA*/
    for(int i=0; i < listaActividades.size(); i+=2) {
      System.out.println("=> Descrio: " + listaActividades.elementAt(i));
      System.out.println("=> Preo: " + listaActividades.elementAt(i+1));
    }

    pagamentosEmFalta = month - numPagamentos/numActividades;
    month-= pagamentosEmFalta-1;
    int valorTotal = 0;
    for(int i=0; i < pagamentosEmFalta; i++) {
      String monthName = null;
      switch(month) {
        case 1: monthName = "Setembro"; break;
        case 2: monthName = "Outubro"; break;
        case 3: monthName = "Novembro"; break;
        case 4: monthName = "Dezembro"; break;
        case 5: monthName = "Janeiro"; break;
        case 6: monthName = "Fevereiro"; break;
        case 7: monthName = "Maro"; break;
        case 8: monthName = "Abril"; break;
        case 9: monthName = "Maio"; break;
        case 10: monthName = "Junho"; break;
        default: monthName = "ERROR"; break;
      }

      for(int j=0; j < listaActividades.size(); j+=2) {
        System.out.println("=> Descrio: " + listaActividades.elementAt(j) + " " + monthName);
        dados.addElement(new String(listaActividades.elementAt(j) + " " + monthName));
        System.out.println("=> Preo: " + listaActividades.elementAt(j+1));
        dados.addElement(listaActividades.elementAt(j+1));
        valorTotal+= ((Integer)listaActividades.elementAt(j+1)).intValue();
      }
      month++;
    }
    /**/System.out.println("===> TOTAL: ");
    /**/System.out.println("===>        " + valorTotal);
    dados.addElement(new Integer(valorTotal));

    System.out.println("Numero de Pagamentos Necessarios=" + pagamentosEmFalta);
    return dados;
    //return null;
  }

  public int getCurrentMonth() {
    java.util.Date date = new java.util.Date();

    String dateTempString=new String();
    try{
      SimpleDateFormat formatter = new SimpleDateFormat ("MM");
      dateTempString = formatter.format(date);
    } catch(Exception e) { e.printStackTrace();}

    return new Integer(dateTempString).intValue();
  }

  public String criancaDados(String nome) {
    ResultSet rs;
    Statement stmt;
    dadosCrianca = new Vector();

    try   {
		  stmt = conn.createStatement ();
		  rs =  stmt.executeQuery("select codigo, fotografia " +
                              "from criancas " +
                              "where nome= '" + nome + "'");

      int photoID = 0;
      if(rs.next()) {
        photoID = rs.getInt("codigo");
        BufferedInputStream bis = new BufferedInputStream( rs.getBinaryStream("fotografia") );
        ByteFileStream.CreateFile(bis, new String("crianca" + photoID + ".jpg"));
        dadosCrianca.addElement(new Integer(rs.getInt("codigo")));
        dadosCrianca.addElement(nome);
        dadosCrianca.addElement(new String("crianca" + photoID + ".jpg"));
        stmt.close();
        return new String("crianca" + photoID + ".jpg");
      }
      else {
        stmt.close();
        return null;
      }
    }
    catch (SQLException e){
      System.out.println("Error in getting criancas from db " + e);
		  return null;
    }
  }

  public Vector registarPagamento() {
    System.out.println("Called Registar Pagamento");

    int codCrianca = ((Integer)dadosCrianca.elementAt(0)).intValue();
    PreparedStatement ps;
    String sql;
    int paramindex;
    int codigo=-1;
    Vector inscLista = new Vector();
    ResultSet rs;
    Statement stmt;
    Vector confirmacao = new Vector();

    try {
      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select max(codigo) from recibos");
      if (rs.next()) codigo = rs.getInt("max(codigo)") + 1;
      else codigo = 1;
      stmt.close();
      System.out.println("Select 1");

      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select codigo, preco " +
                                        "from inscricoes " +
                                        "where cri_codigo = " + codCrianca);
      while(rs.next()) {
        inscLista.addElement(new Integer(rs.getInt("codigo")));
        inscLista.addElement(new Integer(rs.getInt("preco")));
      }
      stmt.close();
      System.out.println("Select 2");


      sql = "INSERT INTO recibos (data, valor, codigo, ins_codigo) VALUES ( ?, ?, ?, ?)";

      System.out.println("Pagamentos em falta: " + pagamentosEmFalta);
      System.out.println("N Inscricoes: " + inscLista.size());


      java.sql.Date data = new java.sql.Date(new java.util.Date().getTime());

      for(int i=0; i < pagamentosEmFalta; i++) {
        for(int j=0; j < inscLista.size(); j+=2) {
          sql = "INSERT INTO recibos (data, valor, codigo, ins_codigo) VALUES ( ?, ?, ?, ?)";
          ps = conn.prepareStatement(sql);
          paramindex=1;

          //ps.setDate(paramindex++, new java.sql.Date(new java.util.Date().getTime()));
          ps.setDate(paramindex++, data);
          ps.setInt(paramindex++, ((Integer)inscLista.elementAt(j+1)).intValue());
          ps.setInt(paramindex++, codigo);
          ps.setInt(paramindex++, ((Integer)inscLista.elementAt(j)).intValue());
          ps.executeUpdate();
          ps.close();
          System.out.println("INSERT");


          System.out.println("===============");
          System.out.println(((Integer)inscLista.elementAt(j+1)).intValue());
          System.out.println(codigo);
          System.out.println(((Integer)inscLista.elementAt(j)).intValue());
          codigo++;
        }
      }
    }
    catch(SQLException e) {
      System.out.println("Failed to insert payment: " + e);
      return null;
    }

    System.out.println("It inserted the data");
    confirmacao.addElement((String)dadosCrianca.elementAt(1));
    confirmacao.addElement((String)dadosCrianca.elementAt(2));
    confirmacao.addElement((Integer)dados.elementAt(dados.size()-1));
    return confirmacao;
}


  public Vector dadosPagamentos() {
    Vector dados = new Vector();
    int codCrianca = ((Integer)dadosCrianca.elementAt(0)).intValue();
    String nomeCrianca = (String)dadosCrianca.elementAt(1);
    String fotoCrianca = (String)dadosCrianca.elementAt(2);

    dados.addElement(nomeCrianca);
    dados.addElement(fotoCrianca);

    Statement stmt;
    ResultSet rs;

    /*try {
      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select*/ return null;

  }

  public Vector listaRecibos() {
    dados = new Vector();
    int codCrianca = ((Integer)dadosCrianca.elementAt(0)).intValue();
    String nomeCrianca = (String)dadosCrianca.elementAt(1);
    String fotoCrianca = (String)dadosCrianca.elementAt(2);

    dados.addElement(nomeCrianca);
    dados.addElement(fotoCrianca);

    System.out.println("Saved in vector child data");

    Statement stmt;
    ResultSet rs;

    int month = getCurrentMonth() - 8; /*number months 1(sep) to 10(june)*/
    int numPagamentos = -1;
    int numActividades = -1;

    try {
      stmt = conn.createStatement();
      rs =  stmt.executeQuery("select r.codigo Recibo, r.data Data, a.descricao Descricao, r.valor Valor " +
                              "from  recibos r, actividades a, inscricoes i " +
                              "where r.ins_codigo = i.codigo and " +
                              "      i.act_codigo = a.codigo and " +
                              "      i.cri_codigo =  " + codCrianca + " " +
                              "order by r.codigo");

      while(rs.next()) {
        dados.addElement(String.valueOf(rs.getInt("Recibo")));

        String date = rs.getDate("Data").toString(); //return yyyy-mm-dd
        String ano = date.substring(0, 4);
        int mes = Integer.valueOf(date.substring(5, 7)).intValue();
        String dia = date.substring(8, 10);
        String data = null;

        switch(mes) {
          case 1: data = new String(dia + " Janeiro " + ano); break;
          case 2: data = new String(dia + " Fevereiro " + ano); break;
          case 3: data = new String(dia + " Maro " + ano); break;
          case 4: data = new String(dia + " Abril " + ano); break;
          case 5: data = new String(dia + " Maio " + ano); break;
          case 6: data = new String(dia + " Junho " + ano); break;
          case 7: data = new String(dia + " Julho " + ano); break;
          case 8: data = new String(dia + " Agosto " + ano); break;
          case 9: data = new String(dia + " Setembro " + ano); break;
          case 10: data = new String(dia + " Outubro " + ano); break;
          case 11: data = new String(dia + " Novembro " + ano); break;
          case 12: data = new String(dia + " Dezembro " + ano); break;
          default: break;
        }

        dados.addElement(data);
        dados.addElement(rs.getString("Descricao"));
        dados.addElement(String.valueOf(rs.getInt("Valor")));
      }
      stmt.close();
    }
    catch ( SQLException se ) {
      System.out.println(se);
      return null;
    }

    return dados;
  }
}
